unit flashdemofrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_utils, dx_vgcore, dx_vglayer,
  dx_flash, dx_controls, fe_flashplayer;

type
  TfrmFlashDemo = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    GUIObjectLayer1: TdxGUIObjectLayer;
    Root2: TvxLayout;
    HudTrackBar1: TvxHudTrackBar;
    HudTrackBar2: TvxHudTrackBar;
    Rectangle1: TvxRectangle;
    HudButton1: TvxHudButton;
    OpenDialog1: TOpenDialog;
    FlashPlayer1: TdxFlashPlayer;
    feFlashList1: TfeFlashList;
    GUIText1: TdxGUIText;
    GUIText2: TdxGUIText;
    GuiWindow: TdxGUIObjectLayer;
    Root3: TvxLayout;
    HudWindow1: TvxHudWindow;
    FlashPlayer2: TvxFlashPlayer;
    HudLabel1: TvxHudLabel;
    HudLabel2: TvxHudLabel;
    procedure HudTrackBar1Change(Sender: TObject);
    procedure HudTrackBar2Change(Sender: TObject);
    procedure HudButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure RecreateMesh;
  public
    { Public declarations }
  end;

var
  frmFlashDemo: TfrmFlashDemo;

implementation

{$R *.dfm}

type
  TdxHackLayer = class(TdxFlashPlayer);

procedure TfrmFlashDemo.FormCreate(Sender: TObject);
begin
  RecreateMesh
end;

procedure TfrmFlashDemo.RecreateMesh;
const
  Res = 40;
var
  x, y: integer;
  s, xx, yy: single;
  curx, cury, curz: single;
begin
  // recreate Layer mesh
  SetLength(TdxHackLayer(FlashPlayer1).FPlane.MeshVertices, Res * Res);
  for y := 0 to Res - 1 do
    for x := 0 to Res - 1 do
    begin
      xx := (-0.5 + (x / (Res - 1))) * 1;
      yy := (-0.5 + (y / (Res - 1))) * 1;
      curz := -0.5 + sin((x / (res - 1)) * Pi);
      curx := -0.5 + (x / (Res - 1));
      cury := -0.5 + (y / (Res - 1));

      TdxHackLayer(FlashPlayer1).FPlane.MeshVertices[x + (y * Res)] := TexVertexNormal(curx, curz, cury, 0, -1, 0, (x / (Res - 1)), 1 - (y / (Res - 1)));
    end;
  SetLength(TdxHackLayer(FlashPlayer1).FPlane.MeshIndices, Res * Res * 6);
  for y := 0 to Res - 2 do
    for x := 0 to Res - 2 do
    begin
      TdxHackLayer(FlashPlayer1).FPlane.MeshIndices[(x + (y * Res)) * 6 + 0] := x + (y * Res);
      TdxHackLayer(FlashPlayer1).FPlane.MeshIndices[(x + (y * Res)) * 6 + 2] := x + 1 + (y * Res);
      TdxHackLayer(FlashPlayer1).FPlane.MeshIndices[(x + (y * Res)) * 6 + 1] := x + ((y + 1) * Res);
      TdxHackLayer(FlashPlayer1).FPlane.MeshIndices[(x + (y * Res)) * 6 + 3] := x + ((y + 1) * Res);
      TdxHackLayer(FlashPlayer1).FPlane.MeshIndices[(x + (y * Res)) * 6 + 5] := x + 1 + (y * Res);
      TdxHackLayer(FlashPlayer1).FPlane.MeshIndices[(x + (y * Res)) * 6 + 4] := x + 1 + ((y + 1) * Res);
    end;
  TdxHackLayer(FlashPlayer1).FPlane.CalcNormals;
  FlashPlayer1.Repaint; 
end;

procedure TfrmFlashDemo.HudTrackBar1Change(Sender: TObject);
begin
  FlashPlayer1.RotateAngle.Z := HudTrackBar1.Value;
end;

procedure TfrmFlashDemo.HudTrackBar2Change(Sender: TObject);
begin
  FlashPlayer1.Scale.Y := HudTrackBar2.Value;
end;

procedure TfrmFlashDemo.HudButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    FlashPlayer1.Movie := OpenDialog1.FileName;
    FlashPlayer2.Movie := OpenDialog1.FileName;
  end;
end;

end.
